function [Score]=SC_IQA(ref_image, dis_image, sal_map, ratio)
% score: quality score
% I_ref: ref image (graylevel)
% I_dis: dis_image (graylevel)
% sal_map: saliency map
% ratio: the ratio of extracted blocks, initially set to 1

if (nargin<4)
        ratio = 1;
end

[H_tform_matrix]=Mo_Com(ref_image,dis_image);

if H_tform_matrix.T(1,1)>=1.005
    recovered = imwarp(im2single(ref_image),H_tform_matrix, 'OutputView',imref2d(size(I_ref)));
    ref_image=recovered*255;
end

Score=block_shift_psnr(double(ref_image),double(dis_image),double(sal_map),ratio);%*bet(j);