function [x_matched]=block_shift(y_s, x_s,I_d, I, N, range)
% y_d,x_d are the coordinate of the pixel to be matched
% I_d: the distorted image
% I: the reference image
% N: block size, must be odd
% range: searching window
% x_matched: matched index in x_axis in the ref image

[H, W]=size(I_d);

% if the searching block overstep the image boundary
sr_s=x_s-range;
sr_ed=x_s+range;
if sr_s<1
    sr_s=1;
end
if (W-sr_ed)<N
    sr_ed=W-N;
end
if y_s<1
    y_s=1;
end
if (H-y_s)<N
    y_s=H-N;
end

Block_d=I_d(y_s:(y_s+N-1),x_s:(x_s+N-1));
x_matched=x_s;
Block_o=I(y_s:(y_s+N-1),x_s:(x_s+N-1));
Epsilon=100;
se_d=double(Block_d(:));
se_o=double(Block_o(:));
v_d=var(se_d);
v_o=var(se_o);
c_do=mean(se_d.*se_o)-mean(se_d)*mean(se_o);
co_index_0=(Epsilon+c_do)/(v_d+v_o+Epsilon);
if N > 256
    co_index=co_index_0;
else
    co_index=0.5;
end

for i=sr_s:sr_ed% searching range

    Block_o=I(y_s:(y_s+N-1),i:(i+N-1));
    se_d=double(Block_d(:));
    se_o=double(Block_o(:));
    v_d=var(se_d);
    v_o=var(se_o);
    c_do=mean(se_d.*se_o)-mean(se_d)*mean(se_o);
    co_index_i=(Epsilon+c_do)/(v_d+v_o+Epsilon);
    
    %----There is a lot difference between the dis and ref images in
    %----both luminance and contrast(captured by different camera). 
    %----So if the correlation index is not bigger enough (1.1 times) 
    %----than the original one, do NOT update----
    if (co_index_i>(co_index_0)*1.1)&&(co_index_i>co_index)
        co_index=co_index_i;
        x_matched=i;
    end
end
