function score=block_shift_psnr(I_ref,I_dis,sal_map, ratio)
% score: quality score
% I_ref: ref image (graylevel)
% I_dis: dis_image (graylevel)
% sal_map: saliency map
% ratio: the ratio of extracted blocks


[H_d,W_d]=size(I_dis);
[H_r,W_r]=size(I_ref);
H=min(H_d,H_r);
W=min(W_d,W_r);
N=64;
N2=8;


H_b2=fix(H/N2);
W_b2=fix(W/N2);
b_se=zeros(H_b2,W_b2);
t_size=fix(N/N2);
shift_table=zeros(t_size,t_size);


for i=1:N:(H-N+1)
    for j=1:N:(W-N+1)
        sal_temp=sum(sum(sal_map(i:(i+N-1),j:(j+N-1))));
        if sal_temp>0
         
            x_matched=block_shift(i, j,I_dis, I_ref, N, 30);

            Block_d=I_dis(i:(i+N-1),j:(j+N-1));
            Block_o=I_ref(i:(i+N-1),x_matched:(x_matched+N-1));

            b_sal=sal_map(i:(i+N-1),j:(j+N-1));

            for m=1:N2:N
                for n=1:N2:N
                    sal_remp2=sum(sum(b_sal(m:(m+N2-1),n:(n+N2-1))));
                    
                    if sal_remp2>0
                        i_match=block_shift(m, n,Block_d, Block_o, N2, 5);
                        b_d=Block_d(m:(m+N2-1),n:(n+N2-1));
                        b_o=Block_o(m:(m+N2-1),i_match:(i_match+N2-1));

                        
                        block_mini=(b_d-b_o).^2;%%---MSE---
%                         block_mini=ssim(b_d,b_o);%%---SSIM---
                        shift_table(ceil(m/N2),ceil(n/N2))=(abs(i_match-n)+1)+N2;

                        block_mask=b_sal(m:(m+N2-1),n:(n+N2-1));
                        block_lini_se=double(block_mini).*block_mask;

                        b_se(ceil((i+m-1)/N2), ceil((j+n-1)/N2))=sum(sum(block_lini_se))/sal_remp2;
                    end
                end
            end

        end
    end
end
x=b_se(:);
topsize=fix(numel(b_se)/100)*ratio;
[B,ind]=sort(x,'descend');
%-----PSNR--------
mse=sum(B(1:topsize))/topsize;
score=10*log10(255*255/mse);
%------SSIM-----------
% score=sum(B(1:topsize))/topsize;